Summary: Belgian Electronic Identity Card - PKCS11 library
Name: Belgium-EID-pkcs11
Version: 1.4
Release: 1
Packager: Zetes NV/SA
Vendor: Rijksregister - Registre National - National Register
Group: System Environment/Libraries
License: see the included license files

%description
Nederlands:
Deze PKCS11 bibliotheek kan gebruikt worden voor cryptografische bewerkingen
met de Belgische electronische identiteitskaart. Bij voorbeeld als
authenticatiemiddel om aan te loggen op een web site of om electronische
documenten te ondertekenen met een wettelijk bindende handtekening.

Franais:
Cette bibliothque PKCS11 peut tre employe pour des oprations cryptographiques avec
la carte d'identit lectronique belge. Par exemple, vous pourriez l'employer
pour vous authentifier (par exemple sur un site Web) ou pour signer les documents
lectroniques avec une signature lgalement valide.

Deutsch:
Diese Bibliothek PKCS11 kann fr Verschlsselungsbetriebe mit dem belgischen
elektronischen Personalausweis benutzt werden. Z.B. konnten Sie sie verwenden,
um sich (z.B. auf einer Web site) oder fr das Unterzeichnen der elektronischen Dokumente
mit einer rechtsverbindlichen Unterzeichnung zu beglaubigen.

English:
This PKCS11 library can be used for cryptographic operations with the Belgian
electronic identity card. For example, you could use it to authenticate
yourself (e.g. on a web site) or for signing electronic documents with a legally
binding signature.

%install
rm -f /usr/local/bin/belpic-pkcs11-tool
rm -f /usr/local/bin/belpic-tool
rm -f /usr/local/lib/Belgium-EID-pkcs11.so
rm -f /usr/local/lib/pkcs11/Belgium-EID-pkcs11.so
rm -f /usr/local/lib/libbelpic.so.0
rm -f /usr/local/lib/libbelpic.so.0.0.8
rm -f /usr/local/man/man1/belpic-tool.1
rm -f /usr/local/man/man1/belpic-pkcs11-tool.1

install -c libbelpic.so.0.0.8 /usr/local/lib/libbelpic.so.0.0.8
ln -s /usr/local/lib/libbelpic.so.0.0.8 /usr/local/lib/libbelpic.so.0

install -c Belgium-EID-pkcs11.so /usr/local/lib/pkcs11/Belgium-EID-pkcs11.so
ln -s /usr/local/lib/pkcs11/Belgium-EID-pkcs11.so /usr/local/lib/Belgium-EID-pkcs11.so

install -c belpic-tool /usr/local/bin/belpic-tool
install -c belpic-pkcs11-tool /usr/local/bin/belpic-pkcs11-tool

install -c -m 644 belpic.conf /usr/local/etc/belpic.conf

install -c -m 644 belpic-tool.1 /usr/local/man/man1/belpic-tool.1
install -c -m 644 belpic-pkcs11-tool.1 /usr/local/man/man1/belpic-pkcs11-tool.1

%files
/usr/local/lib/libbelpic.so.0.0.8
/usr/local/lib/libbelpic.so.0
/usr/local/lib/pkcs11/Belgium-EID-pkcs11.so
/usr/local/lib/Belgium-EID-pkcs11.so
/usr/local/bin/belpic-tool
/usr/local/bin/belpic-pkcs11-tool
/usr/local/man/man1/belpic-tool.1
/usr/local/man/man1/belpic-pkcs11-tool.1
%config /usr/local/etc/belpic.conf
%doc readme_en.txt readme_nl.txt readme_fr.txt pkcs11_install_netsc_moz.htm pkcs11_uninstall_netsc_moz.htm LICENSE COPYING

%clean
